angular.module('starter.controllers', ['starter.services'])

.controller('MainCtrl', function($scope, $timeout, $state, checkUrlService, startService) {
	$scope.msg = {val:"", cls: "", queue: 0};
	$scope.url = {val: ""};
	$scope.status = "status-eva";
	$scope.testId = "";
	$scope.cache = "";

	var urlStatusAni, sock;

	var badUrl = function(code) {
		if (urlStatusAni) {
			urlStatusAni.stop();
		}
		$scope.status = "status-eva";
		if (code === 1) {
			$scope.msg.val = "请输入被测网址";
		} else if (code === 2) {
			$scope.msg.val = "该网站内容过大，暂不支持";
		} else if (code === 3) {
			$scope.msg.val = "系统正忙，请稍后再试";
		} else {
			$scope.msg.val = "无法解析该网址，请输入正确的网址";
		}
		$scope.msg.cls = "error";
	};

	var checkUrl = function() {
		urlStatusAni = new countUp('url-status', 0, 99, 0, 60);
		urlStatusAni.start();
		$scope.status = "status-check-url";
		$scope.msg.val = "正在解析网址，请稍候";
		$scope.msg.cls = "";
	};

	var checkQueue = function(queue) {
		urlStatusAni.stop();
		$scope.msg.val = "在您前面还有" + queue + "人在等待测试，请稍候";
		$scope.msg.cls = "";
		$scope.msg.queue = queue;
		$scope.status = "status-check-queue";

	};

	var queueUpdate = function(queue) {
		$scope.msg.val = "在您前面还有" + queue + "人在等待测试，请稍候";
		$scope.msg.cls = "";
		$scope.msg.queue = queue;
	};

	var showResult = function() {
		$scope.msg = {val:"", cls: "", queue: 0};
		$scope.url = {val: ""};
		$scope.status = "status-eva";
		$state.go("result",{testId: $scope.testId});
	};

	var initSockConn = function() {
		if (sock) {
			sock.close();
		}
		var sockUrl = "http://www.mmtrix.com:8008/mobileInstat";
		sock = new SockJS(sockUrl);

		sock.onopen = function() {
			var msg = {
				method: "urlCheck",
				args: {testId: $scope.testId}
			};
			sock.send(JSON.stringify(msg));
		};

		sock.onmessage = function(e) {
			var data = JSON.parse(e.data);
			if (data.method === "urlCheck") {
				var urlStatus = data.res.status;
				if (urlStatus === "finished") {
					startService.success = function(result) {
    					if (result.code === 0) {
    						if (result.queue > 0) {
	    						checkQueue(result.queue);
	    						var queueMsg = {
	    							method: "queueLen",
	    							args: {testId: $scope.testId}
	    						};
	    						sock.send(JSON.stringify(queueMsg));
    						} else {
    							sock.close();
    							showResult();
    							console.log("jump: /evaluate/result/testid/" + $scope.testId);
    						}
    					} else {
    						badUrl(3);
    					}
    				};
    				startService.error = function() {
    					badUrl(3);
    					console.log("error");
    				};
    				startService.start($scope.testId);
				} else {
					if (urlStatus === "toolarge") {
						badUrl(2);
					} else {
						badUrl();
					}
				}
			} else if (data.method === "queueLen") {
				var pcQueue = parseInt(data.res.pc[0]/9);
				var netQueue = data.res.net.waitingNum;
				var queue = Math.max(pcQueue, netQueue);
				queueUpdate(queue);
				if (queue === 0) {
					sock.close();
					showResult();
					console.log("jump: /evaluate/result/testid/" + $scope.testId);
				}
			}
		};
	};

	//清理错误信息
	$scope.clearError = function(){
		$scope.msg.val = "";
		$scope.msg.cls = "";
	};

	$scope.inputBlur = function() {
		if (window.cordova && window.cordova.plugins.Keyboard) {
			cordova.plugins.Keyboard.close();
		}
	};

	$scope.submitUrl = function(){
		var urlValue = $.trim($scope.url.val);
		if (urlValue == "") {
			badUrl(1);
			return false;
		}

		var reg = /^(https?:\/\/)?(((([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(%[\da-f]{2})|[!\$&'\(\)\*\+,;=]|:)*@)?(((\d|[1-9]\d|1\d\d|2[0-4]\d|25[0-5])\.(\d|[1-9]\d|1\d\d|2[0-4]\d|25[0-5])\.(\d|[1-9]\d|1\d\d|2[0-4]\d|25[0-5])\.(\d|[1-9]\d|1\d\d|2[0-4]\d|25[0-5]))|((([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))\.)+(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))\.?)(:\d*)?)(\/((([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(%[\da-f]{2})|[!\$&'\(\)\*\+,;=]|:|@)+(\/(([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(%[\da-f]{2})|[!\$&'\(\)\*\+,;=]|:|@)*)*)?)?(\?((([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(%[\da-f]{2})|[!\$&'\(\)\*\+,;=\[\]]|:|@)|[\uE000-\uF8FF]|\/|\?)*)?(#((([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(%[\da-f]{2})|[!\$&'\(\)\*\+,;=]|:|@)|\/|\?)*)?$/i;
    	if (reg.test(urlValue) === false) {
    		badUrl();
    		return;
    	}

    	checkUrl();

    	checkUrlService.success = function(data) {
    		if (data.code === 0) {
    			$scope.testId = data.testId;
    			initSockConn();
    		} else if (data.code === 3) {
    			$scope.testId = data.testId;
    			$scope.cache = data.cache;
    			$timeout(function() {
    				startService.success = function(result) {
    					if (result.code === 0) {
    						checkQueue(1);
    						$timeout(function() {
    							queueUpdate(0);
    							console.log("jump: /evaluate/result/testid/" + $scope.testId);
    						}, 3000);
    					} else {
    						badUrl(3);
    					}
    				};
    				startService.error = function() {
    					badUrl(3);
    					console.log("error");
    				};
    				startService.start($scope.testId, $scope.cache);
    			}, 3000);
    		} else {
    			badUrl();
    		}
    	};
    	checkUrlService.error = function() {
    		badUrl(3);
    		console.log("error");
    	};
    	checkUrlService.check(urlValue);

	};

	$scope.onInput = function($event) {
		if ($event.charCode == 13) {
			if (window.cordova && window.cordova.plugins.Keyboard) {
				cordova.plugins.Keyboard.close();
			}
			$scope.submitUrl();
		}
	};
})

.controller('ResultCtrl', function($scope, $state, $stateParams) {
	$scope.resultUrl = "blank.html";
	$scope.titleHeight = $("#result-title").height();
	$scope.bodyHeight = $("#result").height() - $("#result-title").height();
	$scope.resultUrl = "http://www.mmtrix.com/evaluate/result/testid/" + $stateParams.testId + "?app=true";
	console.log($scope.resultUrl);
	$scope.back = function(){
		$state.go("main");
	};
});